/*
 *	crlf.c: EOL chars(CR/LF) operation filter
 *	Copyright  1995  씎Y(oo), HGG00736@niftyserve.or.jp
 */
#include	<stdio.h>
#ifdef	HAVE_STDLIB_H
#include	<stdlib.h>
#endif
#ifdef	HAVE_UNISTD_H
#include	<unistd.h>
#endif
#include	"readln.h"
#ifdef	HAVE_IPRINT_H
#define	CALL_IPRINT_ALL
#include	"iprint.h"
#endif

#ifndef	VERSION
#define	VERSION	"1.0"
#endif

int	mode = 0;

static int imode, omode;
static char*	progname;

void	crlf(FILE* fp)
{
	char*	line;

	while (line = readln_b(fp)) {
		fputs(line, stdout);
		if (mode != 2)	putchar('\r');
		if (mode != 1)	putchar('\n');
	}
}

static void term(void)
{
	fmode(stdin,  imode);
	fmode(stdout, omode);
}

static void	init(void)
{
	imode = stdin->_flag  & (_IOTEXT|_IOBINARY);
	omode = stdout->_flag & (_IOTEXT|_IOBINARY);
	onexit(term);
	fmode(stdout, _IOBINARY);
}

static volatile void usage(void)
{
	fputs(
	"usage: crlf [-Vhnr] [t@C]\n"
	"   -V  o[W\\n"
	"   -h  ̃bZ[W̕\\n"
	"   -n  \'\\n\'(LF) ̂ݏo\n"
	"   -r  \'\\r\'(CR) ̂ݏo\n"
	, stderr);
	exit(-1);
}

int	main(int ac, char** av)
{
	int	ind = 0;
	char*	ptr;
	FILE*	fp;

	progname = av[ind++];
	init();

	while (ac > ind && av[ind][0] == '-') {
		for (ptr = av[ind] + 1; *ptr; ptr++) {
			switch (*ptr) {
			case 'c':
			case 'r':	mode = 1;	break;
			case 'l':
			case 'f':
			case 'n':	mode = 2;	break;
			case 'V':	mode |= 4;	break;
			case 'h':
			default:	mode |= 8;	break;
			}
		}
		ind++;
	}
	if (mode & 4) {
		fputs("crlf-" VERSION "  Copyright 1995 oo\n", stderr);
		if (mode & 8) usage();
		if (ac == ind) return 0;
	}
	if (mode & 8) usage();
	if (ac == ind) {
		if (isatty(fileno(stdin))) {
			usage();
		}
		fmode(stdin, _IOBINARY);
		crlf(stdin);
	}
	else {
		while (ac > ind) {
			if (fp = fopen(av[ind], "rb")) {
				crlf(fp);
				fclose(fp);
			}
			else {
				fputs(progname, stderr);
				fputs(": cannot open ", stderr);
				fputs(av[ind], stderr);
				fputc('\n', stderr);
			}
			ind++;
		}
	}
	return 0;
}
